]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: Remove #! line from test-lib.sh
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 #
4 # This program is free software: you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation, either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program.  If not, see http://www.gnu.org/licenses/ .
16
17 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
18     echo "Error: The notmuch test suite requires a bash version >= 4.0"
19     echo "due to use of associative arrays within the test suite."
20     echo "Please try again with a newer bash (or help us fix the"
21     echo "test suite to be more portable). Thanks."
22     exit 1
23 fi
24
25 # if --tee was passed, write the output not only to the terminal, but
26 # additionally to the file test-results/$BASENAME.out, too.
27 case "$GIT_TEST_TEE_STARTED, $* " in
28 done,*)
29         # do not redirect again
30         ;;
31 *' --tee '*|*' --va'*)
32         mkdir -p test-results
33         BASE=test-results/$(basename "$0" .sh)
34         (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
35          echo $? > $BASE.exit) | tee $BASE.out
36         test "$(cat $BASE.exit)" = 0
37         exit
38         ;;
39 esac
40
41 # Keep the original TERM for say_color and test_emacs
42 ORIGINAL_TERM=$TERM
43
44 # For repeatability, reset the environment to known value.
45 LANG=C
46 LC_ALL=C
47 PAGER=cat
48 TZ=UTC
49 TERM=dumb
50 export LANG LC_ALL PAGER TERM TZ
51 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
52 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
53
54 # Protect ourselves from common misconfiguration to export
55 # CDPATH into the environment
56 unset CDPATH
57
58 unset GREP_OPTIONS
59
60 # Convenience
61 #
62 # A regexp to match 5 and 40 hexdigits
63 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
64 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
65
66 _x04='[0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
67 _x32="$_x04$_x04$_x04$_x04$_x04$_x04$_x04$_x04"
68
69 # Each test should start with something like this, after copyright notices:
70 #
71 # test_description='Description of this test...
72 # This test checks if command xyzzy does the right thing...
73 # '
74 # . ./test-lib.sh
75 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
76                 TERM=$ORIGINAL_TERM &&
77                 export TERM &&
78                 [ -t 1 ] &&
79                 tput bold >/dev/null 2>&1 &&
80                 tput setaf 1 >/dev/null 2>&1 &&
81                 tput sgr0 >/dev/null 2>&1
82         ) &&
83         color=t
84
85 while test "$#" -ne 0
86 do
87         case "$1" in
88         -d|--d|--de|--deb|--debu|--debug)
89                 debug=t; shift ;;
90         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
91                 immediate=t; shift ;;
92         -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
93                 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
94         -h|--h|--he|--hel|--help)
95                 help=t; shift ;;
96         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
97                 verbose=t; shift ;;
98         -q|--q|--qu|--qui|--quie|--quiet)
99                 quiet=t; shift ;;
100         --with-dashes)
101                 with_dashes=t; shift ;;
102         --no-color)
103                 color=; shift ;;
104         --no-python)
105                 # noop now...
106                 shift ;;
107         --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
108                 valgrind=t; verbose=t; shift ;;
109         --tee)
110                 shift ;; # was handled already
111         --root=*)
112                 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
113                 shift ;;
114         *)
115                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
116         esac
117 done
118
119 if test -n "$debug"; then
120     print_subtest () {
121         printf " %-4s" "[$((test_count - 1))]"
122     }
123 else
124     print_subtest () {
125         true
126     }
127 fi
128
129 if test -n "$color"; then
130         say_color () {
131                 (
132                 TERM=$ORIGINAL_TERM
133                 export TERM
134                 case "$1" in
135                         error) tput bold; tput setaf 1;; # bold red
136                         skip)  tput bold; tput setaf 2;; # bold green
137                         pass)  tput setaf 2;;            # green
138                         info)  tput setaf 3;;            # brown
139                         *) test -n "$quiet" && return;;
140                 esac
141                 shift
142                 printf " "
143                 printf "$@"
144                 tput sgr0
145                 print_subtest
146                 )
147         }
148 else
149         say_color() {
150                 test -z "$1" && test -n "$quiet" && return
151                 shift
152                 printf " "
153                 printf "$@"
154                 print_subtest
155         }
156 fi
157
158 error () {
159         say_color error "error: $*\n"
160         GIT_EXIT_OK=t
161         exit 1
162 }
163
164 say () {
165         say_color info "$*"
166 }
167
168 test "${test_description}" != "" ||
169 error "Test script did not set test_description."
170
171 if test "$help" = "t"
172 then
173         echo "Tests ${test_description}"
174         exit 0
175 fi
176
177 echo $(basename "$0"): "Testing ${test_description}"
178
179 exec 5>&1
180
181 test_failure=0
182 test_count=0
183 test_fixed=0
184 test_broken=0
185 test_success=0
186
187 die () {
188         code=$?
189         rm -rf "$TEST_TMPDIR"
190         if test -n "$GIT_EXIT_OK"
191         then
192                 exit $code
193         else
194                 echo >&5 "FATAL: Unexpected exit with code $code"
195                 exit 1
196         fi
197 }
198
199 GIT_EXIT_OK=
200 # Note: TEST_TMPDIR *NOT* exported!
201 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
202 trap 'die' EXIT
203
204 test_decode_color () {
205         sed     -e 's/.\[1m/<WHITE>/g' \
206                 -e 's/.\[31m/<RED>/g' \
207                 -e 's/.\[32m/<GREEN>/g' \
208                 -e 's/.\[33m/<YELLOW>/g' \
209                 -e 's/.\[34m/<BLUE>/g' \
210                 -e 's/.\[35m/<MAGENTA>/g' \
211                 -e 's/.\[36m/<CYAN>/g' \
212                 -e 's/.\[m/<RESET>/g'
213 }
214
215 q_to_nul () {
216         perl -pe 'y/Q/\000/'
217 }
218
219 q_to_cr () {
220         tr Q '\015'
221 }
222
223 append_cr () {
224         sed -e 's/$/Q/' | tr Q '\015'
225 }
226
227 remove_cr () {
228         tr '\015' Q | sed -e 's/Q$//'
229 }
230
231 # Generate a new message in the mail directory, with a unique message
232 # ID and subject. The message is not added to the index.
233 #
234 # After this function returns, the filename of the generated message
235 # is available as $gen_msg_filename and the message ID is available as
236 # $gen_msg_id .
237 #
238 # This function supports named parameters with the bash syntax for
239 # assigning a value to an associative array ([name]=value). The
240 # supported parameters are:
241 #
242 #  [dir]=directory/of/choice
243 #
244 #       Generate the message in directory 'directory/of/choice' within
245 #       the mail store. The directory will be created if necessary.
246 #
247 #  [filename]=name
248 #
249 #       Store the message in file 'name'. The default is to store it
250 #       in 'msg-<count>', where <count> is three-digit number of the
251 #       message.
252 #       
253 #  [body]=text
254 #
255 #       Text to use as the body of the email message
256 #
257 #  '[from]="Some User <user@example.com>"'
258 #  '[to]="Some User <user@example.com>"'
259 #  '[subject]="Subject of email message"'
260 #  '[date]="RFC 822 Date"'
261 #
262 #       Values for email headers. If not provided, default values will
263 #       be generated instead.
264 #
265 #  '[cc]="Some User <user@example.com>"'
266 #  [reply-to]=some-address
267 #  [in-reply-to]=<message-id>
268 #  [references]=<message-id>
269 #  [content-type]=content-type-specification
270 #  '[header]=full header line, including keyword'
271 #
272 #       Additional values for email headers. If these are not provided
273 #       then the relevant headers will simply not appear in the
274 #       message.
275 #
276 #  '[id]=message-id'
277 #
278 #       Controls the message-id of the created message.
279 gen_msg_cnt=0
280 gen_msg_filename=""
281 gen_msg_id=""
282 generate_message ()
283 {
284     # This is our (bash-specific) magic for doing named parameters
285     local -A template="($@)"
286     local additional_headers
287
288     gen_msg_cnt=$((gen_msg_cnt + 1))
289     if [ -z "${template[filename]}" ]; then
290         gen_msg_name="msg-$(printf "%03d" $gen_msg_cnt)"
291     else
292         gen_msg_name=${template[filename]}
293     fi
294
295     if [ -z "${template[id]}" ]; then
296         gen_msg_id="${gen_msg_name%:2,*}@notmuch-test-suite"
297     else
298         gen_msg_id="${template[id]}"
299     fi
300
301     if [ -z "${template[dir]}" ]; then
302         gen_msg_filename="${MAIL_DIR}/$gen_msg_name"
303     else
304         gen_msg_filename="${MAIL_DIR}/${template[dir]}/$gen_msg_name"
305         mkdir -p "$(dirname "$gen_msg_filename")"
306     fi
307
308     if [ -z "${template[body]}" ]; then
309         template[body]="This is just a test message (#${gen_msg_cnt})"
310     fi
311
312     if [ -z "${template[from]}" ]; then
313         template[from]="Notmuch Test Suite <test_suite@notmuchmail.org>"
314     fi
315
316     if [ -z "${template[to]}" ]; then
317         template[to]="Notmuch Test Suite <test_suite@notmuchmail.org>"
318     fi
319
320     if [ -z "${template[subject]}" ]; then
321         template[subject]="Test message #${gen_msg_cnt}"
322     fi
323
324     if [ -z "${template[date]}" ]; then
325         template[date]="Fri, 05 Jan 2001 15:43:57 +0000"
326     fi
327
328     additional_headers=""
329     if [ ! -z "${template[header]}" ]; then
330         additional_headers="${template[header]}
331 ${additional_headers}"
332     fi
333
334     if [ ! -z "${template[reply-to]}" ]; then
335         additional_headers="Reply-To: ${template[reply-to]}
336 ${additional_headers}"
337     fi
338
339     if [ ! -z "${template[in-reply-to]}" ]; then
340         additional_headers="In-Reply-To: ${template[in-reply-to]}
341 ${additional_headers}"
342     fi
343
344     if [ ! -z "${template[cc]}" ]; then
345         additional_headers="Cc: ${template[cc]}
346 ${additional_headers}"
347     fi
348
349     if [ ! -z "${template[references]}" ]; then
350         additional_headers="References: ${template[references]}
351 ${additional_headers}"
352     fi
353
354     if [ ! -z "${template[content-type]}" ]; then
355         additional_headers="Content-Type: ${template[content-type]}
356 ${additional_headers}"
357     fi
358
359     # Note that in the way we're setting it above and using it below,
360     # `additional_headers' will also serve as the header / body separator
361     # (empty line in between).
362
363     cat <<EOF >"$gen_msg_filename"
364 From: ${template[from]}
365 To: ${template[to]}
366 Message-Id: <${gen_msg_id}>
367 Subject: ${template[subject]}
368 Date: ${template[date]}
369 ${additional_headers}
370 ${template[body]}
371 EOF
372 }
373
374 # Generate a new message and add it to the database.
375 #
376 # All of the arguments and return values supported by generate_message
377 # are also supported here, so see that function for details.
378 add_message ()
379 {
380     generate_message "$@" &&
381     notmuch new > /dev/null
382 }
383
384 # Deliver a message with emacs and add it to the database
385 #
386 # Uses emacs to generate and deliver a message to the mail store.
387 # Accepts arbitrary extra emacs/elisp functions to modify the message
388 # before sending, which is useful to doing things like attaching files
389 # to the message and encrypting/signing.
390 emacs_deliver_message ()
391 {
392     local subject="$1"
393     local body="$2"
394     shift 2
395     # before we can send a message, we have to prepare the FCC maildir
396     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
397     $TEST_DIRECTORY/smtp-dummy sent_message &
398     smtp_dummy_pid=$!
399     test_emacs \
400         "(let ((message-send-mail-function 'message-smtpmail-send-it)
401                (smtpmail-smtp-server \"localhost\")
402                (smtpmail-smtp-service \"25025\"))
403            (notmuch-hello)
404            (notmuch-mua-mail)
405            (message-goto-to)
406            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
407            (message-goto-subject)
408            (insert \"${subject}\")
409            (message-goto-body)
410            (insert \"${body}\")
411            $@
412            (message-send-and-exit))"
413     # opportunistically quit smtp-dummy in case above fails.
414     { echo QUIT > /dev/tcp/localhost/25025; } 2>/dev/null
415     wait ${smtp_dummy_pid}
416     notmuch new >/dev/null
417 }
418
419 # Generate a corpus of email and add it to the database.
420 #
421 # This corpus is fixed, (it happens to be 50 messages from early in
422 # the history of the notmuch mailing list), which allows for reliably
423 # testing commands that need to operate on a not-totally-trivial
424 # number of messages.
425 add_email_corpus ()
426 {
427     rm -rf ${MAIL_DIR}
428     if [ -d $TEST_DIRECTORY/corpus.mail ]; then
429         cp -a $TEST_DIRECTORY/corpus.mail ${MAIL_DIR}
430     else
431         cp -a $TEST_DIRECTORY/corpus ${MAIL_DIR}
432         notmuch new >/dev/null
433         cp -a ${MAIL_DIR} $TEST_DIRECTORY/corpus.mail
434     fi
435 }
436
437 test_begin_subtest ()
438 {
439     if [ -n "$inside_subtest" ]; then
440         exec 1>&6 2>&7          # Restore stdout and stderr
441         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
442     fi
443     test_subtest_name="$1"
444     test_reset_state_
445     # Remember stdout and stderr file descriptors and redirect test
446     # output to the previously prepared file descriptors 3 and 4 (see
447     # below)
448     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
449     exec 6>&1 7>&2 >&3 2>&4
450     inside_subtest=t
451 }
452
453 # Pass test if two arguments match
454 #
455 # Note: Unlike all other test_expect_* functions, this function does
456 # not accept a test name. Instead, the caller should call
457 # test_begin_subtest before calling this function in order to set the
458 # name.
459 test_expect_equal ()
460 {
461         exec 1>&6 2>&7          # Restore stdout and stderr
462         inside_subtest=
463         test "$#" = 3 && { prereq=$1; shift; } || prereq=
464         test "$#" = 2 ||
465         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
466
467         output="$1"
468         expected="$2"
469         if ! test_skip "$test_subtest_name"
470         then
471                 if [ "$output" = "$expected" ]; then
472                         test_ok_ "$test_subtest_name"
473                 else
474                         testname=$this_test.$test_count
475                         echo "$expected" > $testname.expected
476                         echo "$output" > $testname.output
477                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
478                 fi
479     fi
480 }
481
482 # Like test_expect_equal, but takes two filenames.
483 test_expect_equal_file ()
484 {
485         exec 1>&6 2>&7          # Restore stdout and stderr
486         inside_subtest=
487         test "$#" = 3 && { prereq=$1; shift; } || prereq=
488         test "$#" = 2 ||
489         error "bug in the test script: not 2 or 3 parameters to test_expect_equal"
490
491         output="$1"
492         expected="$2"
493         if ! test_skip "$test_subtest_name"
494         then
495                 if diff -q "$expected" "$output" >/dev/null ; then
496                         test_ok_ "$test_subtest_name"
497                 else
498                         testname=$this_test.$test_count
499                         cp "$output" $testname.output
500                         cp "$expected" $testname.expected
501                         test_failure_ "$test_subtest_name" "$(diff -u $testname.expected $testname.output)"
502                 fi
503     fi
504 }
505
506 NOTMUCH_NEW ()
507 {
508     notmuch new | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
509 }
510
511 notmuch_search_sanitize ()
512 {
513     sed -r -e 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
514 }
515
516 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
517 notmuch_show_sanitize ()
518 {
519     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
520 }
521 notmuch_show_sanitize_all ()
522 {
523     sed \
524         -e 's| filename:.*| filename:XXXXX|' \
525         -e 's| id:[^ ]* | id:XXXXX |'
526 }
527
528 notmuch_json_show_sanitize ()
529 {
530     sed -e 's|, |,\n |g' | \
531         sed \
532         -e 's|"id": "[^"]*",|"id": "XXXXX",|' \
533         -e 's|"filename": "[^"]*",|"filename": "YYYYY",|'
534 }
535
536 # End of notmuch helper functions
537
538 # Use test_set_prereq to tell that a particular prerequisite is available.
539 # The prerequisite can later be checked for in two ways:
540 #
541 # - Explicitly using test_have_prereq.
542 #
543 # - Implicitly by specifying the prerequisite tag in the calls to
544 #   test_expect_{success,failure,code}.
545 #
546 # The single parameter is the prerequisite tag (a simple word, in all
547 # capital letters by convention).
548
549 test_set_prereq () {
550         satisfied="$satisfied$1 "
551 }
552 satisfied=" "
553
554 test_have_prereq () {
555         case $satisfied in
556         *" $1 "*)
557                 : yes, have it ;;
558         *)
559                 ! : nope ;;
560         esac
561 }
562
563 # declare prerequisite for the given external binary
564 test_declare_external_prereq () {
565         binary="$1"
566         test "$#" = 2 && name=$2 || name="$binary(1)"
567
568         hash $binary 2>/dev/null || eval "
569         test_missing_external_prereq_${binary}_=t
570 $binary () {
571         echo -n \"\$test_subtest_missing_external_prereqs_ \" | grep -qe \" $name \" ||
572         test_subtest_missing_external_prereqs_=\"\$test_subtest_missing_external_prereqs_ $name\"
573         false
574 }"
575 }
576
577 # Explicitly require external prerequisite.  Useful when binary is
578 # called indirectly (e.g. from emacs).
579 # Returns success if dependency is available, failure otherwise.
580 test_require_external_prereq () {
581         binary="$1"
582         if [ "$(eval echo -n \$test_missing_external_prereq_${binary}_)" = t ]; then
583                 # dependency is missing, call the replacement function to note it
584                 eval "$binary"
585         else
586                 true
587         fi
588 }
589
590 # You are not expected to call test_ok_ and test_failure_ directly, use
591 # the text_expect_* functions instead.
592
593 test_ok_ () {
594         if test "$test_subtest_known_broken_" = "t"; then
595                 test_known_broken_ok_ "$@"
596                 return
597         fi
598         test_success=$(($test_success + 1))
599         say_color pass "%-6s" "PASS"
600         echo " $@"
601 }
602
603 test_failure_ () {
604         if test "$test_subtest_known_broken_" = "t"; then
605                 test_known_broken_failure_ "$@"
606                 return
607         fi
608         test_failure=$(($test_failure + 1))
609         test_failure_message_ "FAIL" "$@"
610         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
611         return 1
612 }
613
614 test_failure_message_ () {
615         say_color error "%-6s" "$1"
616         echo " $2"
617         shift 2
618         echo "$@" | sed -e 's/^/        /'
619         if test "$verbose" != "t"; then cat test.output; fi
620 }
621
622 test_known_broken_ok_ () {
623         test_reset_state_
624         test_fixed=$(($test_fixed+1))
625         say_color pass "%-6s" "FIXED"
626         echo " $@"
627 }
628
629 test_known_broken_failure_ () {
630         test_reset_state_
631         test_broken=$(($test_broken+1))
632         test_failure_message_ "BROKEN" "$@"
633         return 1
634 }
635
636 test_debug () {
637         test "$debug" = "" || eval "$1"
638 }
639
640 test_run_ () {
641         test_cleanup=:
642         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
643         eval >&3 2>&4 "$1"
644         eval_ret=$?
645         eval >&3 2>&4 "$test_cleanup"
646         return 0
647 }
648
649 test_skip () {
650         test_count=$(($test_count+1))
651         to_skip=
652         for skp in $NOTMUCH_SKIP_TESTS
653         do
654                 case $this_test.$test_count in
655                 $skp)
656                         to_skip=t
657                 esac
658         done
659         if test -z "$to_skip" && test -n "$prereq" &&
660            ! test_have_prereq "$prereq"
661         then
662                 to_skip=t
663         fi
664         case "$to_skip" in
665         t)
666                 test_report_skip_ "$@"
667                 ;;
668         *)
669                 test_check_missing_external_prereqs_ "$@"
670                 ;;
671         esac
672 }
673
674 test_check_missing_external_prereqs_ () {
675         if test -n "$test_subtest_missing_external_prereqs_"; then
676                 say_color skip >&3 "missing prerequisites:"
677                 echo "$test_subtest_missing_external_prereqs_" >&3
678                 test_report_skip_ "$@"
679         else
680                 false
681         fi
682 }
683
684 test_report_skip_ () {
685         test_reset_state_
686         say_color skip >&3 "skipping test:"
687         echo " $@" >&3
688         say_color skip "%-6s" "SKIP"
689         echo " $1"
690 }
691
692 test_subtest_known_broken () {
693         test_subtest_known_broken_=t
694 }
695
696 test_expect_success () {
697         test "$#" = 3 && { prereq=$1; shift; } || prereq=
698         test "$#" = 2 ||
699         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
700         test_reset_state_
701         if ! test_skip "$@"
702         then
703                 test_run_ "$2"
704                 run_ret="$?"
705                 # test_run_ may update missing external prerequisites
706                 test_check_missing_external_prereqs_ "$@" ||
707                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
708                 then
709                         test_ok_ "$1"
710                 else
711                         test_failure_ "$@"
712                 fi
713         fi
714 }
715
716 test_expect_code () {
717         test "$#" = 4 && { prereq=$1; shift; } || prereq=
718         test "$#" = 3 ||
719         error "bug in the test script: not 3 or 4 parameters to test-expect-code"
720         test_reset_state_
721         if ! test_skip "$@"
722         then
723                 test_run_ "$3"
724                 run_ret="$?"
725                 # test_run_ may update missing external prerequisites,
726                 test_check_missing_external_prereqs_ "$@" ||
727                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
728                 then
729                         test_ok_ "$2"
730                 else
731                         test_failure_ "$@"
732                 fi
733         fi
734 }
735
736 # test_external runs external test scripts that provide continuous
737 # test output about their progress, and succeeds/fails on
738 # zero/non-zero exit code.  It outputs the test output on stdout even
739 # in non-verbose mode, and announces the external script with "* run
740 # <n>: ..." before running it.  When providing relative paths, keep in
741 # mind that all scripts run in "trash directory".
742 # Usage: test_external description command arguments...
743 # Example: test_external 'Perl API' perl ../path/to/test.pl
744 test_external () {
745         test "$#" = 4 && { prereq=$1; shift; } || prereq=
746         test "$#" = 3 ||
747         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
748         descr="$1"
749         shift
750         test_reset_state_
751         if ! test_skip "$descr" "$@"
752         then
753                 # Announce the script to reduce confusion about the
754                 # test output that follows.
755                 say_color "" " run $test_count: $descr ($*)"
756                 # Run command; redirect its stderr to &4 as in
757                 # test_run_, but keep its stdout on our stdout even in
758                 # non-verbose mode.
759                 "$@" 2>&4
760                 if [ "$?" = 0 ]
761                 then
762                         test_ok_ "$descr"
763                 else
764                         test_failure_ "$descr" "$@"
765                 fi
766         fi
767 }
768
769 # Like test_external, but in addition tests that the command generated
770 # no output on stderr.
771 test_external_without_stderr () {
772         # The temporary file has no (and must have no) security
773         # implications.
774         tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
775         stderr="$tmp/git-external-stderr.$$.tmp"
776         test_external "$@" 4> "$stderr"
777         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
778         descr="no stderr: $1"
779         shift
780         if [ ! -s "$stderr" ]; then
781                 rm "$stderr"
782                 test_ok_ "$descr"
783         else
784                 if [ "$verbose" = t ]; then
785                         output=`echo; echo Stderr is:; cat "$stderr"`
786                 else
787                         output=
788                 fi
789                 # rm first in case test_failure exits.
790                 rm "$stderr"
791                 test_failure_ "$descr" "$@" "$output"
792         fi
793 }
794
795 # This is not among top-level (test_expect_success)
796 # but is a prefix that can be used in the test script, like:
797 #
798 #       test_expect_success 'complain and die' '
799 #           do something &&
800 #           do something else &&
801 #           test_must_fail git checkout ../outerspace
802 #       '
803 #
804 # Writing this as "! git checkout ../outerspace" is wrong, because
805 # the failure could be due to a segv.  We want a controlled failure.
806
807 test_must_fail () {
808         "$@"
809         test $? -gt 0 -a $? -le 129 -o $? -gt 192
810 }
811
812 # test_cmp is a helper function to compare actual and expected output.
813 # You can use it like:
814 #
815 #       test_expect_success 'foo works' '
816 #               echo expected >expected &&
817 #               foo >actual &&
818 #               test_cmp expected actual
819 #       '
820 #
821 # This could be written as either "cmp" or "diff -u", but:
822 # - cmp's output is not nearly as easy to read as diff -u
823 # - not all diff versions understand "-u"
824
825 test_cmp() {
826         $GIT_TEST_CMP "$@"
827 }
828
829 # This function can be used to schedule some commands to be run
830 # unconditionally at the end of the test to restore sanity:
831 #
832 #       test_expect_success 'test core.capslock' '
833 #               git config core.capslock true &&
834 #               test_when_finished "git config --unset core.capslock" &&
835 #               hello world
836 #       '
837 #
838 # That would be roughly equivalent to
839 #
840 #       test_expect_success 'test core.capslock' '
841 #               git config core.capslock true &&
842 #               hello world
843 #               git config --unset core.capslock
844 #       '
845 #
846 # except that the greeting and config --unset must both succeed for
847 # the test to pass.
848
849 test_when_finished () {
850         test_cleanup="{ $*
851                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
852 }
853
854 test_done () {
855         GIT_EXIT_OK=t
856         test_results_dir="$TEST_DIRECTORY/test-results"
857         mkdir -p "$test_results_dir"
858         test_results_path="$test_results_dir/${0%.sh}-$$"
859
860         echo "total $test_count" >> $test_results_path
861         echo "success $test_success" >> $test_results_path
862         echo "fixed $test_fixed" >> $test_results_path
863         echo "broken $test_broken" >> $test_results_path
864         echo "failed $test_failure" >> $test_results_path
865         echo "" >> $test_results_path
866
867         echo
868
869         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
870
871         if [ "$test_failure" = "0" ]; then
872             if [ "$test_broken" = "0" ]; then       
873                 rm -rf "$remove_tmp"
874             fi
875             exit 0
876         else
877             exit 1
878         fi
879 }
880
881 emacs_generate_script () {
882         # Construct a little test script here for the benefit of the user,
883         # (who can easily run "run_emacs" to get the same emacs environment
884         # for investigating any failures).    
885         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
886 #!/bin/sh
887 export PATH=$PATH
888 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
889
890 # Here's what we are using here:
891 #
892 # --no-init-file        Don't load users ~/.emacs
893 #
894 # --no-site-file        Don't load the site-wide startup stuff
895 #
896 # --directory           Ensure that the local elisp sources are found
897 #
898 # --load                Force loading of notmuch.el and test-lib.el
899
900 exec ${TEST_EMACS} --no-init-file --no-site-file \
901         --directory "$TEST_DIRECTORY/../emacs" --load notmuch.el \
902         --directory "$TEST_DIRECTORY" --load test-lib.el \
903         "\$@"
904 EOF
905         chmod a+x "$TMP_DIRECTORY/run_emacs"
906 }
907
908 test_emacs () {
909         # test dependencies beforehand to avoid the waiting loop below
910         test_require_external_prereq emacs || return
911         test_require_external_prereq emacsclient || return
912
913         if [ -z "$EMACS_SERVER" ]; then
914                 server_name="notmuch-test-suite-$$"
915                 # start a detached session with an emacs server
916                 # user's TERM is given to dtach which assumes a minimally
917                 # VT100-compatible terminal -- and emacs inherits that
918                 TERM=$ORIGINAL_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
919                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
920                                 --no-window-system \
921                                 --eval '(setq server-name \"$server_name\")' \
922                                 --eval '(server-start)' \
923                                 --eval '(orphan-watchdog $$)'" || return
924                 EMACS_SERVER="$server_name"
925                 # wait until the emacs server is up
926                 until test_emacs '()' 2>/dev/null; do
927                         sleep 1
928                 done
929         fi
930
931         emacsclient --socket-name="$EMACS_SERVER" --eval "(progn $@)"
932 }
933
934 test_python() {
935         export LD_LIBRARY_PATH=$TEST_DIRECTORY/../lib
936         export PYTHONPATH=$TEST_DIRECTORY/../bindings/python
937
938         # Some distros (e.g. Arch Linux) ship Python 2.* as /usr/bin/python2,
939         # most others as /usr/bin/python. So first try python2, and fallback to
940         # python if python2 doesn't exist.
941         cmd=python2
942         [[ "$test_missing_external_prereq_python2_" = t ]] && cmd=python
943
944         (echo "import sys; _orig_stdout=sys.stdout; sys.stdout=open('OUTPUT', 'w')"; cat) \
945                 | $cmd -
946 }
947
948 # Creates a script that counts how much time it is executed and calls
949 # notmuch.  $notmuch_counter_command is set to the path to the
950 # generated script.  Use notmuch_counter_value() function to get the
951 # current counter value.
952 notmuch_counter_reset () {
953         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
954         if [ ! -x "$notmuch_counter_command" ]; then
955                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
956                 cat >"$notmuch_counter_command" <<EOF || return
957 #!/bin/sh
958
959 read count < "$notmuch_counter_state_path"
960 echo \$((count + 1)) > "$notmuch_counter_state_path"
961
962 exec notmuch "\$@"
963 EOF
964                 chmod +x "$notmuch_counter_command" || return
965         fi
966
967         echo 0 > "$notmuch_counter_state_path"
968 }
969
970 # Returns the current notmuch counter value.
971 notmuch_counter_value () {
972         if [ -r "$notmuch_counter_state_path" ]; then
973                 read count < "$notmuch_counter_state_path"
974         else
975                 count=0
976         fi
977         echo $count
978 }
979
980 test_reset_state_ () {
981         test -z "$test_init_done_" && test_init_
982
983         test_subtest_known_broken_=
984         test_subtest_missing_external_prereqs_=
985 }
986
987 # called once before the first subtest
988 test_init_ () {
989         test_init_done_=t
990
991         # skip all tests if there were external prerequisites missing during init
992         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
993 }
994
995
996 find_notmuch_path ()
997 {
998     dir="$1"
999
1000     while [ -n "$dir" ]; do
1001         bin="$dir/notmuch"
1002         if [ -x "$bin" ]; then
1003             echo "$dir"
1004             return
1005         fi
1006         dir="$(dirname "$dir")"
1007         if [ "$dir" = "/" ]; then
1008             break
1009         fi
1010     done
1011 }
1012
1013 # Test the binaries we have just built.  The tests are kept in
1014 # test/ subdirectory and are run in 'trash directory' subdirectory.
1015 TEST_DIRECTORY=$(pwd)
1016 if test -n "$valgrind"
1017 then
1018         make_symlink () {
1019                 test -h "$2" &&
1020                 test "$1" = "$(readlink "$2")" || {
1021                         # be super paranoid
1022                         if mkdir "$2".lock
1023                         then
1024                                 rm -f "$2" &&
1025                                 ln -s "$1" "$2" &&
1026                                 rm -r "$2".lock
1027                         else
1028                                 while test -d "$2".lock
1029                                 do
1030                                         say "Waiting for lock on $2."
1031                                         sleep 1
1032                                 done
1033                         fi
1034                 }
1035         }
1036
1037         make_valgrind_symlink () {
1038                 # handle only executables
1039                 test -x "$1" || return
1040
1041                 base=$(basename "$1")
1042                 symlink_target=$TEST_DIRECTORY/../$base
1043                 # do not override scripts
1044                 if test -x "$symlink_target" &&
1045                     test ! -d "$symlink_target" &&
1046                     test "#!" != "$(head -c 2 < "$symlink_target")"
1047                 then
1048                         symlink_target=$TEST_DIRECTORY/valgrind.sh
1049                 fi
1050                 case "$base" in
1051                 *.sh|*.perl)
1052                         symlink_target=$TEST_DIRECTORY/unprocessed-script
1053                 esac
1054                 # create the link, or replace it if it is out of date
1055                 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
1056         }
1057
1058         # override notmuch executable in TEST_DIRECTORY/..
1059         GIT_VALGRIND=$TEST_DIRECTORY/valgrind
1060         mkdir -p "$GIT_VALGRIND"/bin
1061         make_valgrind_symlink $TEST_DIRECTORY/../notmuch
1062         OLDIFS=$IFS
1063         IFS=:
1064         for path in $PATH
1065         do
1066                 ls "$path"/notmuch 2> /dev/null |
1067                 while read file
1068                 do
1069                         make_valgrind_symlink "$file"
1070                 done
1071         done
1072         IFS=$OLDIFS
1073         PATH=$GIT_VALGRIND/bin:$PATH
1074         GIT_EXEC_PATH=$GIT_VALGRIND/bin
1075         export GIT_VALGRIND
1076 else # normal case
1077         notmuch_path=`find_notmuch_path "$TEST_DIRECTORY"`
1078         test -n "$notmuch_path" && PATH="$notmuch_path:$PATH"
1079 fi
1080 export PATH
1081
1082 # Test repository
1083 test="tmp.$(basename "$0" .sh)"
1084 test -n "$root" && test="$root/$test"
1085 case "$test" in
1086 /*) TMP_DIRECTORY="$test" ;;
1087  *) TMP_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1088 esac
1089 test ! -z "$debug" || remove_tmp=$TMP_DIRECTORY
1090 rm -fr "$test" || {
1091         GIT_EXIT_OK=t
1092         echo >&5 "FATAL: Cannot prepare test area"
1093         exit 1
1094 }
1095
1096 # A temporary home directory is needed by at least:
1097 # - emacs/"Sending a message via (fake) SMTP"
1098 # - emacs/"Reply within emacs"
1099 # - crypto/emacs_deliver_message
1100 export HOME="${TMP_DIRECTORY}/home"
1101 mkdir -p "${HOME}"
1102
1103 MAIL_DIR="${TMP_DIRECTORY}/mail"
1104 export GNUPGHOME="${TMP_DIRECTORY}/gnupg"
1105 export NOTMUCH_CONFIG="${TMP_DIRECTORY}/notmuch-config"
1106
1107 mkdir -p "${test}"
1108 mkdir -p "${MAIL_DIR}"
1109
1110 cat <<EOF >"${NOTMUCH_CONFIG}"
1111 [database]
1112 path=${MAIL_DIR}
1113
1114 [user]
1115 name=Notmuch Test Suite
1116 primary_email=test_suite@notmuchmail.org
1117 other_email=test_suite_other@notmuchmail.org;test_suite@otherdomain.org
1118 EOF
1119
1120 emacs_generate_script
1121
1122
1123 # Use -P to resolve symlinks in our working directory so that the cwd
1124 # in subprocesses like git equals our $PWD (for pathname comparisons).
1125 cd -P "$test" || error "Cannot setup test environment"
1126
1127 if test "$verbose" = "t"
1128 then
1129         exec 4>&2 3>&1
1130 else
1131         exec 4>test.output 3>&4
1132 fi
1133
1134 this_test=${0##*/}
1135 for skp in $NOTMUCH_SKIP_TESTS
1136 do
1137         to_skip=
1138         for skp in $NOTMUCH_SKIP_TESTS
1139         do
1140                 case "$this_test" in
1141                 $skp)
1142                         to_skip=t
1143                 esac
1144         done
1145         case "$to_skip" in
1146         t)
1147                 say_color skip >&3 "skipping test $this_test altogether"
1148                 say_color skip "skip all tests in $this_test"
1149                 test_done
1150         esac
1151 done
1152
1153 # Provide an implementation of the 'yes' utility
1154 yes () {
1155         if test $# = 0
1156         then
1157                 y=y
1158         else
1159                 y="$*"
1160         fi
1161
1162         while echo "$y"
1163         do
1164                 :
1165         done
1166 }
1167
1168 # Fix some commands on Windows
1169 case $(uname -s) in
1170 *MINGW*)
1171         # Windows has its own (incompatible) sort and find
1172         sort () {
1173                 /usr/bin/sort "$@"
1174         }
1175         find () {
1176                 /usr/bin/find "$@"
1177         }
1178         sum () {
1179                 md5sum "$@"
1180         }
1181         # git sees Windows-style pwd
1182         pwd () {
1183                 builtin pwd -W
1184         }
1185         # no POSIX permissions
1186         # backslashes in pathspec are converted to '/'
1187         # exec does not inherit the PID
1188         ;;
1189 *)
1190         test_set_prereq POSIXPERM
1191         test_set_prereq BSLASHPSPEC
1192         test_set_prereq EXECKEEPSPID
1193         ;;
1194 esac
1195
1196 test -z "$NO_PERL" && test_set_prereq PERL
1197 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1198
1199 # test whether the filesystem supports symbolic links
1200 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1201 rm -f y
1202
1203 # declare prerequisites for external binaries used in tests
1204 test_declare_external_prereq dtach
1205 test_declare_external_prereq emacs
1206 test_declare_external_prereq emacsclient
1207 test_declare_external_prereq gdb
1208 test_declare_external_prereq gpg
1209 test_declare_external_prereq python
1210 test_declare_external_prereq python2